{-# LANGUAGE DeriveGeneric
  #-} 

module Config (
  ConfigChan (),
  readConfig,
  writeConfig,
  readConfigDefault,
) where

import EffectCapabilities
import GHC.Generics
import ProtectedIO.IOP as IOP

data ConfigChan = ConfigChan deriving Generic
instance Channel ConfigChan

readPerm :: IOPC FileInputPerm
readPerm = receive ConfigChan FileInputPerm

writePerm :: IOPC FileOutputPerm
writePerm = receive ConfigChan FileOutputPerm

readConfig  f   = IOP.readFile  readPerm  f
writeConfig f s = IOP.writeFile writePerm f s

readConfigDefault = readConfig "defaultConfig.txt"