{-# LANGUAGE TypeOperators,
             FlexibleContexts,
             ScopedTypeVariables,
             MultiParamTypeClasses,
             DeriveGeneric,
             FlexibleInstances,
             StandaloneDeriving,
             UndecidableInstances
  #-}

module PriorityQueue (
 PQueueChan (),
 peekByPriority,
) where

import Data.List
import Control.Monad.Error
import MonadStatePV
import EffectCapabilities
import GHC.Generics
import Queue

data PQueueChan = PQueueChan deriving (Show, Generic)
instance Channel PQueueChan

queueState :: QState ReadPerm
queueState = receive PQueueChan ReadPerm

peekByPriority :: (Ord s, MonadStatePV QState n m [s]) =>
                  (s -> s -> Ordering) -> m (Maybe s)
peekByPriority comp = do
               queue <- get queueState
               if null queue
                  then return Nothing
                  else return (Just $ maximumBy comp queue)

