{-# LANGUAGE GeneralizedNewtypeDeriving,
             DeriveDataTypeable,
             DeriveGeneric,
             MultiParamTypeClasses,
             FlexibleInstances
  #-}

module ProtectedIO.IOPClass (
  IOP (),
  IOPC (),
  runIOP,
  MonadIOP (..),
  module ProtectedIO.Permissions,
) where

import System.IO
import Control.Monad.IO.Class
import Control.Monad.Fix
import Control.Applicative
import Text.Printf
import Data.Typeable
import EffectCapabilities
import System.IO
import ProtectedIO.Permissions
import {-# SOURCE #-} Config
import GHC.Generics

instance Send ConfigChan IOPC FileInputPerm
instance Send ConfigChan IOPC FileOutputPerm

data IOPC a = IOPC a deriving (Show, Generic)
instance Capability IOPC a

newtype IOP a = IOP {unIOP :: IO a}
  deriving (Functor, Monad, Typeable,
            MonadFix, Applicative, HPrintfType, PrintfType)

runIOP :: IOP a -> IO a
runIOP pio = unIOP pio

class Monad m => MonadIOP m where
 liftIOP :: IOPC perm -> IO a -> m a

instance MonadIOP IOP where
 liftIOP c io = case checkCapability c of _ -> IOP io